<script>
import CLodop from '@/libs/print/CLodop';
import {getDevice} from '@/tools/print.tool';
import {template60_60} from '@/components/print/template';
import {selectOrderDetail2} from '@/api/prescription/prescriptionAudit';

export default {
  name: 'print_tag_80_50',
  props: {
    id: {type: [String, Number], required: true},
  },
  data() {
    return {
      loaded: false,
      preview: false,
      total: 1,

      tag: `print-preview_${Date.now()}`,
      paper: '包装标签',

      model: null,
      device: null,
      printing: false,
    };
  },
  computed: {
    loading() {
      return !this.loaded || !this.preview;
    },
  },
  mounted() {
    // this.print(true);
  },
  methods: {
    async print(preview = false) {
      const instance = await CLodop();
      const model = await this.getModel();

      template60_60.call(instance, model, `${this.paper}`);

      this.device = await getDevice(`paper:${this.paper}`);
      if (this.device) instance['SET_PRINT_PAGESIZE'](1, 0, 0, this.paper);
      else {
        this.device = await getDevice({width: 60, height: 40}, `name:Gprinter GP-1324D`);
        if (this.device) instance['SET_PRINT_PAGESIZE'](1, '60mm', '40mm', 'CreateCustomPage');
      }
      if (this.device) instance['SET_PRINTER_INDEX'](this.device.index);

      instance['SET_PRINT_COPIES'](this.total);

      if (preview) {
        instance['SET_PREVIEW_WINDOW'](1, 1, 1, 0, 0, `${this.paper}.开始打印`);
        instance['SET_SHOW_MODE']('PREVIEW_IN_BROWSE', true);
        instance['SET_PRINT_MODE']('AUTO_CLOSE_PREWINDOW', true);
        instance['PREVIEW'](this.tag);
      } else if (this.device) {
        if (instance['PRINT']()) this.complete();
        else this.$message.warning(`请检查打印机 (${this.device.name})`);
      } else {
        if (instance['PRINTA']()) this.complete();
        else this.$message.warning(`请检查打印机`);
      }
      this.printing = false;
      this.loaded = true;
    },
    delay() {
      setTimeout(() => {this.preview = true;}, 500);
    },
    complete() {
      this.$message.success(`开始打印`);
      this.$emit('close', true);
    },

    async getModel() {
      if (this.model) return this.model;
      this.model = await selectOrderDetail2({id: this.id});
      return this.model;
    },
  },
};
</script>

<template>
  <div class="print-preview" v-loading="loading">
    <div class="top" :style="{backgroundColor: preview ? '#f0f0f0' : 'transparent'}"></div>
    <iframe :id="tag" @load="delay"></iframe>
    <div style="display: flex; align-items: center; justify-content: space-evenly;">
      <el-button style="width: 100%;" type="primary" :loading="printing" @click="printing = true;print()">打印</el-button>
    </div>
  </div>
</template>

<style scoped lang="scss">
.print-preview {
  margin: auto;
  width: 360px;

  .top {
    height: 40px;
  }

  iframe {
    border: none;
    width: 100%;
    height: 280px;
  }
}
</style>
